
package de.ivu.elect.presentation.wahl.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlterminEdit;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.jee.faces.FacesContextUtil;

public class WahlterminEntarchivierenAction extends AbstractWahlterminAction {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlterminEdit edit;

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLTERMIN_ARCHIVIEREN;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Wahltermin entity) {
    return super.isDisabledInternal(entity) || !entity.getStatus().isArchiviert();
  }

  @Override
  public String doIt(Wahltermin wahltermin) {
    edit.wahlEntarchivieren(wahltermin);

    messages.addInfoMessage("wahltermin.edit.action.unlock.success.message", wahltermin.getName());

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getLabelKey() {
    return "wahltermin.edit.action.unarchive";
  }

  @Override
  public String getIcon() {
    return "fa fa-folder-open";
  }
}
